// NMSServiceQueue.cpp : Defines the entry point for the console application.
//

#include <string.h>
#include "stdafx.h"
#include "NMSServiceQueue.h"

NMSServiceQueue::NMSServiceQueue() : startOfQueue(NULL), endOfQueue(NULL)
{
    // Clients will add service requests as operations commence    
}

NMSServiceQueue::~NMSServiceQueue()
{
    QueueElementPtr aQueueItem;
    
    this->examineQueue();

    while (!queueIsEmpty())
    {
        aQueueItem = remove();

        delete aQueueItem->requiredOperation;
        delete aQueueItem;
        
        this->examineQueue();
    }
}

void NMSServiceQueue::add(QueueElementPtr serviceRequest)
{
    if (queueIsEmpty())
    {
        startOfQueue = serviceRequest;
        startOfQueue->nextQueueElement = NULL;
        endOfQueue = startOfQueue;
        endOfQueue->nextQueueElement = NULL;
    }
    else
    {
        // Handle a single entry queue
        if (startOfQueue == endOfQueue)
        {
            startOfQueue->nextQueueElement = serviceRequest;
        }

        // Add the new element to the end of the queue
        endOfQueue->nextQueueElement = serviceRequest;
        endOfQueue = serviceRequest;
    }
}

const QueueElementPtr NMSServiceQueue::remove(void)
{
    QueueElementPtr tempQueueItem;
    QueueElementPtr nextQueueItem;

    if (queueIsEmpty())
    {
        return NULL;
    }
    else
    {
        tempQueueItem = startOfQueue;
        nextQueueItem = startOfQueue->nextQueueElement;

        if (nextQueueItem != NULL)
            startOfQueue->nextQueueElement = nextQueueItem;

        startOfQueue = tempQueueItem->nextQueueElement;

        return tempQueueItem;
    }
}

void NMSServiceQueue::examineQueue(void)
{
    QueueElementPtr tempQueueItem;

    tempQueueItem = startOfQueue;

    while (tempQueueItem)
    {
        printf("Queue item: %s\n", tempQueueItem->requiredOperation);
        tempQueueItem = tempQueueItem->nextQueueElement;
    }

    printf("\n");
}

bool NMSServiceQueue::queueIsEmpty() const
{
    return (startOfQueue == NULL);
}

QueueElementPtr createQueueItem(char* requiredOperation)
{
    QueueElementPtr aQueueElement = new QueueElement;
    aQueueElement->requiredOperation = new char[strlen(requiredOperation) + 1];
    memcpy(aQueueElement->requiredOperation, requiredOperation,
        strlen(requiredOperation) + 1);
    printf("Queue operation: %s\n", aQueueElement->requiredOperation);
    aQueueElement->nextQueueElement = NULL;

    return aQueueElement;
}

int _tmain(int argc, _TCHAR* argv[])
{
    char serviceRequest1[] = "Enable Link 1";
    char serviceRequest2[] = "Disable Link 4";
    char serviceRequest3[] = "Disable Link 467";

    NMSServiceQueue* aServiceQueue = new NMSServiceQueue();

    aServiceQueue->add(createQueueItem(serviceRequest1));
    aServiceQueue->add(createQueueItem(serviceRequest2));
    aServiceQueue->add(createQueueItem(serviceRequest3));
    aServiceQueue->examineQueue();

    QueueElementPtr anOperation = aServiceQueue->remove();
    if (anOperation)
        printf("Removed a queue element: %s\n", anOperation->requiredOperation);
    aServiceQueue->examineQueue();

    QueueElementPtr anOperation1 = aServiceQueue->remove();
    if (anOperation1)
        printf("Removed a queue element: %s\n", anOperation1->requiredOperation);
    aServiceQueue->examineQueue();

    QueueElementPtr anOperation2 = aServiceQueue->remove();
    if (anOperation2)
        printf("Removed a queue element: %s\n", anOperation2->requiredOperation);
    aServiceQueue->examineQueue();

    delete anOperation->requiredOperation;
    delete anOperation;

    delete anOperation1->requiredOperation;
    delete anOperation1;

    delete anOperation2->requiredOperation;
    delete anOperation2;

    delete aServiceQueue;
 
	return 0;
}